\section{Results}

Dividing the five samples we obtained into training set and testing set (as
specified in \autoref{subsubsec:training-data}) and using them with each of the
approaches mentioned in \autoref{subsec:training} results in matching the
phonemes extracted from a certain audio into the corresponding entries in the
dictionary.

\autoref{fig:dictionary_index} shows the results obtained in MATLAB. The five
rows in the \emph{ind} variable are actually the corresponding positions of the
phonemes of the same digit, in this case \emph{jeden} across the five samples.
We can observe that there are some perfect matches and other close but not
exact matches. This is due to the fact that the samples are obtained from
different people males and females, with different pitch and background noise.


Although we worked on smoothing the signals as much as possible, some parasite
still persists. Another factor that contribute to the non deterministic nature
of the results is the fact that when processing the samples, the results of the
\nameref{subsec:mfcc} are fed into the \nameref{subsec:k-means} with a fixed
amount of clusters. Which should be theoretically the amount of phonemes of the
pronounced digit. But in practice we need to add one or more clusters that will
contain silence signal, the amount of clusters needed for the silence signals
vary with each audio, usually 1, 2 or 3. Additionally in every run the k-means
can return slightly different values for those center which in return causes
the matching to codebook entries to sometimes miss the correct result because
one phoneme to be matched can be equally close to two or more entities in the
codebook. 

\begin{figure}[!htbp]
	\centering
	\includegraphics[
  width=15cm,
  height=20cm,
  keepaspectratio]{dict_index}
    \caption{results of the matched phonemes to dictionary}
    \label{fig:dictionary_index}
\end{figure}

Using the three approaches mentioned in \autoref{subsec:training} we trained
the system and came out with three different codebooks of 14 dimension feature
vectors, that represent the phonemes that should appear in the voicing of
numbers from \emph{0} to \emph{9} (in Polish language) as it is described in
\autoref{subsec:dataset}. In the figures \ref{fig:andreu_phonemplot},
\ref{fig:dani_phonemplot}, \ref{fig:wathek_phonemplot}, a visualization of the
dictionary entries in 2D space is presented. We used four out of the five
samples we have to train these dictionaries and the \emph{t-sne} algorithm to
achieve the dimension compression aiming for a clearer visual representation.
We can observe that sometimes even though points have different colors, the
distance between them is actually not that big. This understanding can also be
used in the color coded audio samples in figures \ref{fig:andreu_voices9},
\ref{fig:dani_voice9} and \ref{fig:wathek_voices9}.

\begin{figure}[H]
	\centering
	\includegraphics[
  width=8.5cm,
  height=13.5cm,
  keepaspectratio]{phonemplot_andreu_method}
    \caption{2D visualization of codebook entries (Phonemes) using Approach 1  }
    \label{fig:andreu_phonemplot}
\end{figure}

\begin{figure}[H]
	\centering
	\includegraphics[
  width=8.5cm,
  height=13.5cm,
  keepaspectratio]{phonemplot_dani_method}
    \caption{2D visualization of codebook entries (Phonemes) using Approach 2}
    \label{fig:dani_phonemplot}
\end{figure}

\begin{figure}[H]
	\centering
	\includegraphics[
  width=8.5cm,
  height=13.5cm,
  keepaspectratio]{phonemplot_wathek_method}
    \caption{2D visualization of codebook entries (Phonemes) using Approach 3}
    \label{fig:wathek_phonemplot}
\end{figure}

In this step, we tested our codebooks using all the dataset
(\autoref{subsec:dataset}). It is worth to repeat that sample number \emph{5}
is not part of the \nameref{subsubsec:training-data} and therefore is only used
in the testing phase. 

A color coded graphic visualization of the training samples as well as the
testing sample can be observed in figures \ref{fig:andreu_voices9},
\ref{fig:dani_voice9} and \ref{fig:wathek_voices9}. The colors refer to which
entry in the codebook that specific part of the signal is more likely closer
to, it is also noted in numbers on each fragment.

\begin{figure}[H]
	\centering
	\includegraphics[width=\textwidth]{voices_digit9_andreu_method}
    \caption{Visualization of audio samples of number \emph{9} color coded and labelled with the corresponding phoneme index in the codebook generated by Approach 1  }
    \label{fig:andreu_voices9}
\end{figure}

\begin{figure}[H]
	\centering
	\includegraphics[width=\textwidth]{voices_digit9_dani_method}
    \caption{Visualization of audio samples of number \emph{9} color coded and labelled with the corresponding phoneme index in the codebook generated by Approach 2}
    \label{fig:dani_voice9}
\end{figure}

\begin{figure}[H]
	\centering
	\includegraphics[width=\textwidth]{voices_digit9_wathek_method}
    \caption{Visualization of audio samples of number \emph{9} color coded and labelled with the corresponding phoneme index in the codebook generated by Approach 3}
    \label{fig:wathek_voices9}
\end{figure}

As mentioned earlier in some cases even that the color is different, the actual
distance between the vectors representing a certain phoneme might very close.
So if we observe figure \ref{fig:andreu_voices9}, in \emph{sample 4} the red
part with the corresponding codebook index 41, is represented in \emph{sample
5} of the same figure by 2 different phonemes namely \emph{29}, \emph{37} and
another \emph{29}. If we take a look at the 2D visualization if figure
\ref{fig:andreu_similarphonemes} we can actually distinguish that the phonemes
in positions \emph{41}, \emph{29}, \emph{37} are fairly close to each other,
meaning they represent very similar sound or phoneme. Same conclusion can be
driven in approaches 2 \& 3 shown in figures \ref{fig:dani_similarphonemes} and
\ref{fig:wathek_similarphonemes} where in fig \ref{fig:dani_similarphonemes}
points with indexes 10, 11 and 19 are representing similar parts of the audio
signal in fig \ref{fig:dani_voice9} namely in samples \emph{2}, \emph{4} and
\emph{5}. While in fig\ref{fig:wathek_voices9}, taking samples \emph{5} and
\emph{4} , we notice in fig\ref{fig:wathek_similarphonemes} how the phonemes
\emph{19}, \emph{17} and \emph{4} are close to each other.

We should remember that those points in the 2D plain are actually vectors of 14
dimensions and are compressed using the \emph{t-sne} algorithm
(\autoref{subsubsec:t-SNE}). This compression might sometimes result in a
slightly different plane representation of the actual data when we run the
program again which causes another source of fluctuation in the results
observed.

\begin{figure}[H]
	\centering
	\includegraphics[
  width=10cm,
  height=15cm,
  keepaspectratio]{magic_approach1}
    \caption{Feature points that represent nearly similar parts in the signal-Approach1}
    \label{fig:andreu_similarphonemes}
\end{figure}

\begin{figure}[H]
	\centering
	\includegraphics[
  width=10cm,
  height=15cm,
  keepaspectratio]{magic_approach2}
    \caption{Feature points that represent nearly similar parts in the signal-Approach2}
    \label{fig:dani_similarphonemes}
\end{figure}

\begin{figure}[H]
	\centering
	\includegraphics[
  width=10cm,
  height=15cm,
  keepaspectratio]{magic_approach3}
    \caption{Feature points that represent nearly similar parts in the signal-Approach3}
    \label{fig:wathek_similarphonemes}
\end{figure}